/*+-------------------------------+*/
/*|Spanish I                      |*/
/*|Extra Credit Project           |*/
/*|-------------------------------|*/
/*|Written by:   Derek Konigsberg |*/
/*+-------------------------------+*/

#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <string.h>


#define catfile  "CATAGORY.CAT"
#define satkfile "SATTACK.CAT"


typedef struct
{
 char name[80];
 int money;
} player;

typedef struct
{
 char text[5][80];
 char answers[4][80];
 int correct;
 int value;
} question;

typedef struct
{
 int index;
 char name[5][80];
 question qst;
} catagory;

typedef struct
{
 char catn[5][80];
 char term[8][80];
 char ans[8][80];
} satkdata;



int numCatagories(char filen[80])
{
 FILE *fd;
 int num;
 fd=fopen(filen,"rt");
 fscanf(fd,"@%i",&num);
 close(fd);
 clrscr();
 return(num);
}



question getQuestion(char filen[80])
{
 FILE *fd;
 int num,n,i,j;
 question info;
 char str[80];
 char str1[80];
 char ch;
 fd=fopen(filen,"rt");
 ch=' ';
 strcpy(info.text[0],"");
 strcpy(info.text[1],"");
 strcpy(info.text[2],"");
 strcpy(info.text[3],"");
 strcpy(info.text[4],"");
 strcpy(info.text[5],"");
 ch=' ';
 i=0;
 while(ch!='+')
 {
  fgets(str,80,fd);
  sscanf(str,"%c",&ch);
  if(ch=='-')
  {
   strcpy(info.text[i],"");
   for(j=1;j<=strlen(str)-2;j++)
    info.text[i][j-1]=str[j];
   info.text[i][strlen(str)-2]='\000';
   i++;
  }
 }
 ch=' ';
 i=0;
 while(ch!='=')
 {
  sscanf(str,"%c",&ch);
  if(ch=='+')
  {
   strcpy(info.answers[i],"");
   for(j=1;j<=strlen(str)-2;j++)
    info.answers[i][j-1]=str[j];
   info.answers[i][strlen(str)-2]='\000';
   i++;
  fgets(str,80,fd);
  }
 }
  strcpy(str1,"");
  for(j=1;j<=strlen(str)-2;j++)
   str1[j-1]=str[j];
  str1[strlen(str)-2]='\000';
  info.correct=atoi(str1);

  fgets(str,80,fd);
  strcpy(str1,"");
  for(j=1;j<=strlen(str)-2;j++)
   str1[j-1]=str[j];
  str1[strlen(str)-2]='\000';
  info.value=atoi(str1);
 fclose(fd);
 return(info);
}



catagory getCatagory(char cfile[80], int index)
{
 FILE *fd;
 int num,n,i,j;
 catagory info;
 char str[80];
 char str1[80];
 char filen[80];
 char ch;
 fd=fopen(cfile,"rt");
 num=0;
 ch=' ';
 while(num!=index)
 {
  fgets(str1,80,fd);
  sscanf(str1,"%c%i",&ch,&n);
  if(ch=='-')
   num=n;
 }
 strcpy(info.name[0],"");
 strcpy(info.name[1],"");
 strcpy(info.name[2],"");
 strcpy(info.name[3],"");
 strcpy(info.name[4],"");
 strcpy(info.name[5],"");
 ch=' ';
 info.index=index;
 i=0;
 while(ch!='#')
 {
  fgets(str,80,fd);
  sscanf(str,"%c",&ch);
  if(ch=='+')
  {
   strcpy(info.name[i],"");
   for(j=1;j<=strlen(str)-2;j++)
    info.name[i][j-1]=str[j];
   info.name[i][strlen(str)-2]='\000';
   i++;
  }
 }
  for(j=1;j<=strlen(str)-2;j++)
   filen[j-1]=str[j];
  filen[strlen(str)-2]='\000';
 fclose(fd);
 if(strcmp(cfile,catfile)==0)
  info.qst=getQuestion(filen);
 return(info);
}



void intro()
{
 setbkcolor(0);
 setcolor(1);
 settextstyle(TRIPLEX_FONT,HORIZ_DIR,8);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 outtextxy(getmaxx()/2,50,"T");
 outtextxy(getmaxx()/2,150,"no");
 outtextxy(getmaxx()/2,250,"hablas");
 outtextxy(getmaxx()/2,350,"espaol!");
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 settextjustify(LEFT_TEXT,TOP_TEXT);
 outtextxy(10,430,"Written by: Derek Konigsberg");
 getch();
}



void names(player *p1, player *p2)
{
 textbackground(BLACK);
 clrscr();
 printf("Player 1 name: ");
 gets(p1->name);
 printf("Player 2 name: ");
 gets(p2->name);
 printf("\n\n");
 printf("Player 1, your buzzer is: 'Q', as in 'Quito'\n");
 printf("Player 2, your buzzer is: 'P' as in 'pollo'\n");
 p1->money=0;
 p2->money=0;
 getch();
}



catagory pick_catagory(char cfile[80], int cnum, player ply,
		       int cn1, int cn2, int cn3)
{
 char ch;
 catagory c1,c2,c3;
 c1=getCatagory(cfile,cn1);
 c2=getCatagory(cfile,cn2);
 c3=getCatagory(cfile,cn3);
 setbkcolor(BLUE);
 cleardevice();
 setcolor(0);
 setfillstyle(SOLID_FILL,RED);
 fillellipse(40,40,40,40);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,4);
 outtextxy(40,40,itoa(cnum,NULL,10));
 setcolor(7);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 outtextxy(500,40,ply.name);
 setcolor(6);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,3);
 settextjustify(LEFT_TEXT,TOP_TEXT);
 outtextxy(40,120,"1)");
 outtextxy(40,220,"2)");
 outtextxy(40,320,"3)");
 setcolor(15);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 settextjustify(LEFT_TEXT,TOP_TEXT);
 outtextxy(100,120,c1.name[0]);
 outtextxy(100,140,c1.name[1]);
 outtextxy(100,220,c2.name[0]);
 outtextxy(100,240,c2.name[1]);
 outtextxy(100,320,c3.name[0]);
 outtextxy(100,340,c3.name[1]);
 ch=getch();
 while((ch!='1')&&(ch!='2')&&(ch!='3'))
  ch=getch();
 if(ch=='1')
  return(c1);
 else if(ch=='2')
  return(c2);
 else if(ch=='3')
  return(c3);
 return(c1);
}



player ask_question(int num, catagory cat, player *p1, player *p2)
{
 char str[80];
 char ch,ch1;
 int flag;
 player winner;
 setbkcolor(BLACK);
 cleardevice();
 setcolor(0);
 setfillstyle(SOLID_FILL,RED);
 fillellipse(40,40,40,40);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,4);
 outtextxy(40,40,itoa(num,NULL,10));
 setcolor(15);
 sprintf(str,"$%i",cat.qst.value);
 outtextxy(500,40,str);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(15);
 outtextxy(getmaxx()/2,100,cat.qst.text[0]);
 outtextxy(getmaxx()/2,120,cat.qst.text[1]);
 outtextxy(getmaxx()/2,140,cat.qst.text[2]);
 outtextxy(getmaxx()/2,160,cat.qst.text[3]);
 outtextxy(getmaxx()/2,180,cat.qst.text[4]);
 settextjustify(LEFT_TEXT,CENTER_TEXT);
 sprintf(str,"1) %s",cat.qst.answers[0]);
 outtextxy(40,250,str);
 sprintf(str,"2) %s",cat.qst.answers[1]);
 outtextxy(40,300,str);
 sprintf(str,"3) %s",cat.qst.answers[2]);
 outtextxy(40,350,str);
 sprintf(str,"4) %s",cat.qst.answers[3]);
 outtextxy(40,400,str);
 setcolor(1);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,5);
 outtextxy(40,440,"1");
 outtextxy(600,440,"2");
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(15);
 sprintf(str,"$%i",p1->money);
 outtextxy(30,470,str);
 sprintf(str,"$%i",p2->money);
 outtextxy(590,470,str);
 ch1=getch();
 while((ch1!='q')&&(ch1!='p'))
  ch1=getch();
 setcolor(3);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,5);
 if(ch1=='q')
  outtextxy(40,440,"1");
 else
  outtextxy(600,440,"2");

 ch=getch();
 while((ch!='1')&&(ch!='2')&&(ch!='3')&&(ch!='4'))
  ch=getch();
 if((ch-48)==cat.qst.correct)
 {
  setcolor(14);
  flag=1;
 }
 else
 {
  setcolor(4);
  flag=0;
 }
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 settextjustify(LEFT_TEXT,CENTER_TEXT);
 sprintf(str,"%c) %s",ch,cat.qst.answers[ch-49]);
 outtextxy(40,(200+((ch-48)*50)),str);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,8);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 if(flag==1)
 {
  if(ch1=='q')
  {
   p1->money+=cat.qst.value;
   winner=*p1;
  }
  else
  {
   p2->money+=cat.qst.value;
   winner=*p2;
  }
  outtextxy(getmaxx()/2,(getmaxy()/2)-50,"Winner!");
  sprintf(str,"+ $%i",cat.qst.value);
  outtextxy(getmaxx()/2,(getmaxy()/2)+50,str);
 }
 else
 {
  if(ch1=='q')
  {
   p1->money-=cat.qst.value;
   winner=*p2;
  }
  else
  {
   p2->money-=cat.qst.value;
   winner=*p1;
  }
  outtextxy(getmaxx()/2,(getmaxy()/2)-50,"Looser!");
  sprintf(str,"- $%i",cat.qst.value);
  outtextxy(getmaxx()/2,(getmaxy()/2)+50,str);
 }


 getch();
 return(winner);
}



int inOrder(int num,int count,int order[40])
{
 int i,j;
 j=0;
 for(i=0;i<=count;i++)
 {
  if(num==order[i])
   j=1;
 }
 return(j);
}



void sattackScreen()
{
 int i;
 setbkcolor(0);
 cleardevice();
 settextstyle(DEFAULT_FONT,HORIZ_DIR,10);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 setcolor(LIGHTGRAY);
 for(i=10;i>=1;i--)
 {
  outtextxy((getmaxx()/2)+i,(getmaxy()/2)-(100+i),"SPANISH");
  outtextxy((getmaxx()/2)+i,(getmaxy()/2)+(100-i),"ATTACK");
 }
 setcolor(BLUE);
 outtextxy(getmaxx()/2,(getmaxy()/2)-100,"SPANISH");
 outtextxy(getmaxx()/2,(getmaxy()/2)+100,"ATTACK");
 getch();
}



void sattack(int cnum, player actp, player *p1, player *p2)
{
 int index;
 FILE *fd,*fd1;
 int num,n,i,j,k,l,flag;
 int torder[8],aorder[8];
 satkdata info;
 char str[80];
 char str1[80];
 char filen[80];
 char ch;
 int c1,c2,c3;
 catagory cat;
 int ncat,cunum,pnum,ppnum;
 ncat=numCatagories(satkfile);
 cunum=random(ncat+1);
 c1=cunum;
 pnum=cunum;
 while(cunum==pnum)
  cunum=random(ncat+1);
 c2=cunum;
 ppnum=cunum;
 while((cunum==pnum)||(cunum==ppnum))
  cunum=random(ncat+1);
 c3=cunum;
 cat=pick_catagory(satkfile, cnum, actp, c1, c2, c3);
 sattackScreen();
 index=cat.index;
 fd1=fopen(satkfile,"rt");
 num=0;
 ch=' ';
 while(num!=index)
 {
  fgets(str1,80,fd1);
  sscanf(str1,"%c%i",&ch,&n);
  if(ch=='-')
   num=n;
 }
 for(i=0;i<=5;i++)
  strcpy(info.catn[i],"");
 ch=' ';
 i=0;
 while(ch!='#')
 {
  fgets(str,80,fd1);
  sscanf(str,"%c",&ch);
  if(ch=='+')
  {
   strcpy(info.catn[i],"");
   for(j=1;j<=strlen(str)-2;j++)
    info.catn[i][j-1]=str[j];
   info.catn[i][strlen(str)-2]='\000';
   i++;
  }
 }
  for(j=1;j<=strlen(str)-2;j++)
   filen[j-1]=str[j];
  filen[strlen(str)-2]='\000';
 fclose(fd1);

 fd=fopen(filen,"rt");
 ch=' ';

 for(i=0;i<=8;i++)
  strcpy(info.term[i],"");

 for(i=0;i<=8;i++)
  strcpy(info.ans[i],"");

 ch=' ';
 i=0;
 while(i<=7)
 {
  fgets(str,80,fd);
  sscanf(str,"%c",&ch);
  if(ch=='?')
  {
   strcpy(info.term[i],"");
   for(j=1;j<=strlen(str)-2;j++)
    info.term[i][j-1]=str[j];
   info.term[i][strlen(str)-2]='\000';
   fgets(str,80,fd);
   strcpy(info.ans[i],"");
   for(j=1;j<=strlen(str)-2;j++)
    info.ans[i][j-1]=str[j];
   info.ans[i][strlen(str)-2]='\000';
   i++;
  }
 }
 fclose(fd);

 setbkcolor(BLACK);
 cleardevice();
 setcolor(1);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,5);
 outtextxy(40,440,"1");
 outtextxy(600,440,"2");
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(15);
 sprintf(str,"$%i",p1->money);
 outtextxy(30,470,str);
 sprintf(str,"$%i",p2->money);
 outtextxy(590,470,str);
 setcolor(0);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 for(i=0;i<=7;i++)
  torder[i]=-9999;
 torder[0]=random(8);
 for(i=1;i<=7;i++)
 {
  k=random(8);
  while(inOrder(k,i,torder)==1)
  {
   k=random(8);
  }
  torder[i]=k;
 }
 for(i=0;i<=7;i++)
  aorder[i]=-9999;
 aorder[0]=random(8);
 for(i=1;i<=7;i++)
 {
  k=random(8);
  while(inOrder(k,i,aorder)==1)
  {
   k=random(8);
  }
  aorder[i]=k;
 }
 flag=0;
 for(k=0;k<=7;k++)
 for(i=0;i<=7;i++)
 {
  settextstyle(SANS_SERIF_FONT,HORIZ_DIR,((i*0.50)+6));
  setcolor(1);
  outtextxy(getmaxx()/2,180+(i*5),info.term[torder[k]]);
  settextstyle(SANS_SERIF_FONT,HORIZ_DIR,2);
  outtextxy(getmaxx()/2,300+(i*5),info.ans[aorder[i]]);
  for(l=1;l<=100;l++)
  {
   if(kbhit())
   {
    ch=getch();
    if((ch=='q')||(ch=='p'))
    {
     setcolor(3);
     settextjustify(CENTER_TEXT,CENTER_TEXT);
     settextstyle(DEFAULT_FONT,HORIZ_DIR,5);
     if(ch=='q')
      outtextxy(40,440,"1");
     else
      outtextxy(600,440,"2");
     settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
     if(torder[k]==aorder[i])
     {
      if(ch=='q')
      {
       setcolor(0);
       sprintf(str,"$%i",p1->money);
       outtextxy(30,470,str);
       p1->money+=1000;
       setcolor(15);
       sprintf(str,"$%i",p1->money);
       outtextxy(30,470,str);
      }
      else
      {
       setcolor(0);
       sprintf(str,"$%i",p2->money);
       outtextxy(590,470,str);
       p2->money+=1000;
       setcolor(15);
       sprintf(str,"$%i",p2->money);
       outtextxy(590,470,str);
      }
     }
     else
     {
      if(ch=='q')
      {
       setcolor(0);
       sprintf(str,"$%i",p1->money);
       outtextxy(30,470,str);
       p1->money-=1000;
       setcolor(15);
       sprintf(str,"$%i",p1->money);
       outtextxy(30,470,str);
      }
      else
      {
       setcolor(0);
       sprintf(str,"$%i",p2->money);
       outtextxy(590,470,str);
       p2->money-=1000;
       setcolor(15);
       sprintf(str,"$%i",p2->money);
       outtextxy(590,470,str);
      }
      flag=1;
     }
     delay(1000);
     setcolor(1);
     settextjustify(CENTER_TEXT,CENTER_TEXT);
     settextstyle(DEFAULT_FONT,HORIZ_DIR,5);
     outtextxy(40,440,"1");
     outtextxy(600,440,"2");
    }
   }
   delay(10);
   if(flag==1)
   {
    flag=0;
    break;
   }
  }
  setcolor(0);
  settextstyle(SANS_SERIF_FONT,HORIZ_DIR,((i*0.50)+6));
  outtextxy(getmaxx()/2,180+(i*5),info.term[torder[k]]);
  settextstyle(SANS_SERIF_FONT,HORIZ_DIR,2);
  outtextxy(getmaxx()/2,300+(i*5),info.ans[aorder[i]]);
 }
}


void winnerScreen(player winner, player loser)
{
 int i;
 char str[80];
 setcolor(15);
 setbkcolor(0);
 cleardevice();
 for(i=0;i<=getmaxy()/2;i+=2)
 {
  setcolor(i);
  setfillstyle(SOLID_FILL,i);
  fillellipse(getmaxx()/2,getmaxy()/2,(getmaxx()/2)-i,(getmaxy()/2)-i);
 }
 setcolor(BROWN);
 setfillstyle(SOLID_FILL,BLACK);
 bar3d((getmaxx()/2)-150,(getmaxy()/2)-150,(getmaxx()/2)+150,(getmaxy()/2)-50,1,1);
 bar3d((getmaxx()/2)-150,(getmaxy()/2)+150,(getmaxx()/2)+150,(getmaxy()/2)+50,1,1);
 setcolor(YELLOW);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 outtextxy((getmaxx()/2),(getmaxy()/2)-130,"Winner");
 outtextxy((getmaxx()/2),(getmaxy()/2)-100,winner.name);
 sprintf(str,"$%i",winner.money);
 outtextxy((getmaxx()/2),(getmaxy()/2)-80,str);
 setcolor(RED);
 outtextxy((getmaxx()/2),(getmaxy()/2)+70,"Loser");
 outtextxy((getmaxx()/2),(getmaxy()/2)+100,loser.name);
 sprintf(str,"$%i",loser.money);
 outtextxy((getmaxx()/2),(getmaxy()/2)+120,str);
 getch();
}


void init()
{
 randomize();
}



void run()
{
 int gdriver=VGA, gmode=VGAHI;
 int order[36];
 int cats,num;
 catagory cat;
 player p1,p2,actp;
 int i,j,k;
 initgraph(&gdriver,&gmode,".\\bgi");
 intro();
 closegraph();
 names(&p1,&p2);
 actp=p1;
 initgraph(&gdriver,&gmode,".\\bgi");
 cats=numCatagories(catfile);
 num=0;
 for(i=0;i<=17;i++)
  order[i]=-9999;
 order[0]=random(cats)+1;
 for(i=1;i<=17;i++)
 {
  k=random(cats)+1;
  while(inOrder(k,i,order)==1)
  {
   k=random(cats)+1;
  }
  order[i]=k;
 }

 for(i=1;i<=6;i++)
 {
  cat=pick_catagory(catfile,i,actp,order[num],order[num+1],order[num+2]);
  num+=3;
  actp=ask_question(i,cat,&p1,&p2);
 }
 sattack(7,actp,&p1,&p2);

 if(p1.money>p2.money)
  winnerScreen(p1,p2);
 else
  winnerScreen(p2,p1);
 closegraph();
}

void done()
{
}



void main()
{
 init();
 run();
 done();
}
